;Last update: 2014-10-16 by Andrea La Camera
;+
;-

function patch_psf_ee, psf, threshold
on_error,2

t0=systime(1)
if (threshold LT 0.) or (threshold GT 1.) then message, 'Threshold must be in range [0,1]'
 
dim=max(size(psf, /DIM))

if (dim mod 2) EQ 1 then dim++

psf2=zero_padding(psf,dim,dim)
ee=dblarr(dim/2)   ;Enclosed Energy as a function of the radius (distance from 
                   ;the centre of the PSF)
stpcrt=1
k0=0.
k1=dim/2.
k=0
if threshold GT 0 then begin
   while (stpcrt) do begin
      k=ceil((k0+k1)/2.)                 
      ee[k-1]=total(psf[dim/2-k:dim/2+k-1, dim/2-k:dim/2+k-1],/DOUBLE)
      if ee[k-1] GT threshold then begin
         k1=k
      endif else begin
         k0=k
      endelse
      if abs(k0-k1) LE 1 then stpcrt = 0
   endwhile                 
endif
;plot, ee
;oplot, make_array(dim/2, value=threshold)
;print, 'Execution time = ', systime(1)-t0
;print, "Delta value = ", k
return, k

end
